/*
 * qfsic[  p[\iEBhEj
 *
 *	By Masahiko Ito <m-ito@myh.no-ip.org>
 *	   Masahiko Ito <m-ito@mbox.kyoto-inet.or.jp>
 *
 *	1992/03/12 Ver 1.0	release
 *	1992/03/13 Ver 1.1
 *	1992/04/01 Ver 2.0
 *	1992/07/06 Ver 2.1
 *	2018/09/11 Ver 2.2
 *
 */

#define		VER			"2.2"

#define		RESENV		"RGTRES"
#define		RESFILE		"RGTool.RES"

#define		ADIC		"ADIC"
#define		DICDIR		"/H0/DIC"
#define		DICM		"x68k_m.dic"
#define		DICS		"x68k_s.dic"

#define		FEP_MODULE	"ask68k"

#define		PWGID		"PWG"
#define		FILEHEADER	"%s %4.4d %4.4d %4.4d\n"

#define		BASEWIDTH	(320+2)
#define		BASEHEIGHT	(200+2)

#define		BTNWIDTH	(8*5)
#define		BTNHEIGHT	20
#define		CTRLWIDTH	(2*BTNWIDTH)
#define		CTRLHEIGHT	(12*BTNHEIGHT)
#define		ICONWIDTH	20
#define		ICONHEIGHT	20
#define		PALWIDTH	320
#define		PALHEIGHT	(2*ICONHEIGHT)
#define		SAVEWIDTH	(32*8)
#define		SAVEHEIGHT	(4+BTNHEIGHT*3+4)
#define		MAGMAPWD	25
#define		MAGMAPHT	25
#define		MAGPIXWD	8
#define		MAGPIXHT	8
#define		MAGWIDTH	(1+MAGMAPWD*MAGPIXWD)
#define		MAGHEIGHT	(1+MAGMAPHT*MAGPIXHT+1)
#define		INVVAL		-9999
#define		STRWIDTH	320
#define		STRHEIGHT	(4+BTNHEIGHT*3+4)

#define		CTRLBTNMAX	20
#define		PALBTNMAX	32
#define		STRBTNMAX	9

#define		PENMAX		14
#define		PATMAX		14

#define		ON	1
#define		OFF	0

#define		DOT		0
#define		LINE	1
#define		BOX		2
#define		BOXF	3
#define		ARC		4
#define		ARCF	5
#define		FILL	6
#define		MAG		7
#define		COPY	8
#define		STR		9
#define		SRC		10
#define		OR		11
#define		XOR		12
#define		NOT		13
#define		SAVE	14
#define		LOAD	15
#define		EXIT	16

#define		PLAIN		0
#define		BOLD		1
#define		OUTLINE		2
#define		SHADOW		3
#define		ITALIC		4
#define		UNDERLINE	5
#define		DOT16		6
#define		DOT24		7
#define		ENTER		8

#define		DEFPEN	0
#define		DEFPAT	14

#define		MIN_X	8
#define		MIN_Y	(8+20)
#define		MAX_X	(1024-8-4)
#define		MAX_Y	(1024-8-4)

typedef	struct {
	PWGMAP	*map;
	int		left;
	int		top;
	int		width;
	int		height;
	char	title[128];
	int		attr;
	int		status;
} BTNLIST;

/* standard function */
extern void	exit();
extern int		write();
extern int		intercept();
extern int		fprintf();
extern char	*getenv();
extern int		fflush();
extern int		_errmsg();
extern int		sscanf();
extern int		fclose();
extern int		readln();
extern int		sprintf();
extern int		fwrite();
extern int		putc();
extern int		fread();
extern int		getc();
extern int		atoi();
extern int		fscanf();
extern int		_fp_getknjmd();
extern int		_fp_setknjmd();
extern int		_fp_knjctrl();
extern mod_exec	*modloadp();
extern int		munlink();

/* original function */
int		GetOpt();
int		Usage();
int		GetRes();
char	*ReadRes();
int		DrawPoint();
int		DrawLine();
int		SetPenSize();
int		GetWhichButton();
int		ReverseButton();
int		DrawPushButton();
int		CtrlRadioButton();
int		DrawRectangle();
int		FillRectangle();
int		DrawArc();
int		FillArc();
int		SetRubberBand();
int		UnSetRubberBand();
int		SaveMap();
int		SaveMapToFile();
int		ErrorDialog();
int		LoadFile();
int		LoadFileToMap();
int		ExitDialog();
int		LocationCheck();
int		CloseMag();
int		OpenMag();
int		CopyMapToMag();
int		DrawMag();
int		CopyArea();
int		OpenStr();
int		ReEnterStr();
int		CloseStr();
int		ClearBtnList();
int		AskStart();
int		AskClose();
int		AskEnd();
